// -*- C++ -*-

// DecimPipe.h
//
// DataPipe functions that do decimation and interpolation
// 
// for Audio Pattern Recognition Language (aprl)
// dpwe@media.mit.edu 1995feb02
//

#ifndef _DECIMPIPE_H
#define _DECIMPIPE_H

#include "DataPipe.h"

class DecimPipe : public DataPipe {	// integer-factor subsamplg (decimate)
private:
    int decim;
    int base;	// need to track how many we've done to get step right
public:
    DecimPipe(int dcm = 1, DataSource *in = 0) : decim(dcm), DataPipe(in)
        { SetIoRatio((double)dcm); base = 0; }
    virtual ~DecimPipe(void)
        { };
    int Update(double /* time */);
};

class LinterpPipe : public DataPipe {	// linear interpolation of datum
private:
    int interp;
    int base;	// need to track how many we've done to get step right
    double lastval;	// for interpolation across blocks
public:
    LinterpPipe(int itp = 1, DataSource *in = 0) : interp(itp), DataPipe(in)
        { SetIoRatio(1.0/(double)itp); base = 0; lastval = 0; }
    virtual ~LinterpPipe(void)
        { };
    int Update(double /* time */);
};

#endif /* _DECIMPIPE_H */
