//  -*- C++ -*-
// 
//  UserCmd.h
//
// eds@media.mit.edu 10 feb 1995

#include "DataPipe.h"

typedef struct {
  char *name;
  int length;
  DATA *s;
  double samplerate;
} UC_parm;

typedef void UserFunc(UC_parm *parms,UC_parm *retval,int ct);

typedef struct {
  char *name;
  UserFunc *func;
} name_table;


class UserCmd : public DataSource {
 private:
  char **names;
  char *cname;
  UserFunc *cfunc;
  DataSource **input;
  int ninputs;
 public:
  UserCmd(char **pnames,DataSource **psrcs,int pninputs,char *pcname=NULL,
	  double srate=0, double buftime=0) ;
  void SetInputs(DataSource **srcs,int n);
  void SetCfunc(char *pcname);
  virtual ~UserCmd(void);
  int Update(double time);
};
  
