#!./aprlwish
#
# demo2.tcl
# 
# Interactive control of real-time filtering
#
# dpwe@media.mit.edu 1995feb14
#

# Enable shell listener
set tcl_interactive 1
# Make window resizable
wm minsize . 1 1

scheduler s

audiosrc  as    -sampleRate 11025
bpfilter  f1    -centerFreq 5000
rms       .     -sampleRate 100
dB        .     -ref 0.01
wavesink  .ws1  -scale 0.05

audiosink .     -input f1

# Define scrollbars to control frq, and Q 
proc scroll1 {sb base} {
    # change the bandpass filter's frequency from 100..10000
    set frq [expr "100*(100-$base)"]
    if { $frq < 100 } { set frq 100 }
    f1 config -centerFreq $frq
    $sb set 100 1 $base $base
}
proc scroll2 {sb base} {
    # change the bandpass filter's Q from 1..50
    set Q [expr "0.5*(100-$base)"]
    if { $Q < 1 } { set Q 1 }
    f1 config -Qfactor $Q
    $sb set 100 1 $base $base
}

scrollbar .sb1     -orient vert -relief flat -command "scroll1 .sb1"
# make the scrollbar have a range of 100, starting at 50
.sb1 set 100 1 50 50

scrollbar .sb2     -orient vert -relief flat -command "scroll2 .sb2"
# make the scrollbar have a range of 100, starting at 50
.sb2 set 100 1 50 50

pack .sb1 .sb2 -side left -fill y
pack .ws1

# Until we tell the scheduler 's' to 'step', no processing occurs.
# So, define a procedure that steps the scheduler, then arranges 
# for the function to be run again after a short delay
proc run {} {
   s step
   after 10 {run}
}

# Start the processing
run

  
