#!./aprlwish
#
# dynfilt.tcl
#
# Dynamic bandpass filtering in aprl - tcl
#
# dpwe@media.mit.edu 1995feb08

# allow terminal inputs as well
set tcl_interactive 1

# make sure the window is resizable
wm minsize . 1 1

proc configval {widget param} {
    # it's tiresome and clumsy to extract the current value from the 
    # standard 'config' response - so do it with this function instead
    return [lindex [$widget config $param] 4]
}

set len 100
set lstart 50
set size 1

proc scrollbarCommand {base} {
    global len size
    set frq [expr "100+100*$base"]
    puts $frq
    bp1 config -center $frq
    .sb set $len $size $base $base
}

scrollbar .sb     -orient horiz -relief flat -command "scrollbarCommand"
pack .sb -expand y -fill x

.sb set $len $size $lstart $lstart

set steptime 0.05
set stepms  [expr "int(1000.0*$steptime)"]
set afterms [expr "int(1000.0*$steptime/2.0)"]

scheduler s -time $steptime

audiosrc  as -sampleRate 44100
#rms       as  -sampleRate 11025 -input as1 
bpfilter   bp1 -input as -centerFreq 2000  -Qfactor 4
bpfilter   bp2 -input as -centerFreq 100   -Qfactor 4
#audiosink ak -input bp
rms       rp1 -sampleRate 50 -input bp1
wavesink  .ws1 -input rp1 -buflen 200 -scale 20
rms       rp2 -sampleRate 50 -input bp2
wavesink  .ws2 -input rp2 -buflen 200 -scale 20

pack .ws1 .ws2

proc run {} {
   global afterms
   s step
#   after $afterms run
   after 10 run
}

# run
