//
// tclBPFilter.cc
//
// tcl interface to BPFilterPipe objects
//
// for aprl - audio pattern recognition language
// dpwe@media.mit.edu 1995feb08
//

#include <stdio.h>
#include <assert.h>
#include "FilterPipe.h"
#define _UNISTD		// inhibit tcl's unistd.h which conflicts with g++

// ----------------------- TEMPLATE DECLARATION OF BANDPASS --------------
#define OBJECT         BandpassFilterPipe
#define TCLNAME	       bpfilter
#define ISPIPE			/* one of ISSINK, ISSOURCE or ISPIPE */
#define STRUCTFIELDS	\
        double centerFreq;	\
	double Qfactor;
#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, centerFreq, CenterFreq, "1000.0")  \
	CONFIGLINE(TK_CONFIG_DOUBLE, Qfactor, Qfactor, "4")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR, IN)						\
	PTR->obj = new BandpassFilterPipe(PTR->centerFreq, PTR->Qfactor, \
					  BPF_2NDO, IN);
#define CONFIGCODE(PTR)							\
	if(PTR->centerFreq != PTR->obj->CtrFrq() 			\
	   || PTR->Qfactor != PTR->obj->Qfactor())			\
	    PTR->obj->ChangeFilt(ptr->centerFreq, ptr->Qfactor);

#include "tclTemplate.h"	// actually define the fns etc.

// ----------------------- TEMPLATE DECLARATION OF LOWPASS --------------
#define OBJECT         LowpassFilterPipe
#define TCLNAME	       lpfilter
#define ISPIPE			/* one of ISSINK, ISSOURCE or ISPIPE */
#define STRUCTFIELDS	\
        double cutoffFreq;	\
	double Qfactor;
#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, cutoffFreq, CutoffFreq, "100.0")	\
	CONFIGLINE(TK_CONFIG_DOUBLE, Qfactor, Qfactor, "4")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR, IN)						\
	PTR->obj = new LowpassFilterPipe(PTR->cutoffFreq, PTR->Qfactor,  \
					 LPF_2NDO, IN);
#define CONFIGCODE(PTR)							\
	if(PTR->cutoffFreq != PTR->obj->CutoffFrq() 			\
	   || PTR->Qfactor != PTR->obj->Qfactor())			\
	    PTR->obj->ChangeFilt(ptr->cutoffFreq, ptr->Qfactor);

#include "tclTemplate.h"	// actually define the fns etc.


// ----------------------- TEMPLATE DECLARATION OF HIGHPASS --------------
#define OBJECT         HighpassFilterPipe
#define TCLNAME	       hpfilter
#define ISPIPE			/* one of ISSINK, ISSOURCE or ISPIPE */
#define STRUCTFIELDS	\
        double cutoffFreq;	\
	double Qfactor;
#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, cutoffFreq, CutoffFreq, "100.0")	\
	CONFIGLINE(TK_CONFIG_DOUBLE, Qfactor, Qfactor, "4")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR, IN)						\
	PTR->obj = new HighpassFilterPipe(PTR->cutoffFreq, PTR->Qfactor,  \
					  HPF_2NDO, IN);
#define CONFIGCODE(PTR)							\
	if(PTR->cutoffFreq != PTR->obj->CutoffFrq() 			\
	   || PTR->Qfactor != PTR->obj->Qfactor())			\
	    PTR->obj->ChangeFilt(ptr->cutoffFreq, ptr->Qfactor);

#include "tclTemplate.h"	// actually define the fns etc.


