//
// tclDataCombiner.cc
//
// tcl interface to DataCombiner objects
//
// for aprl - audio pattern recognition language
// dpwe@media.mit.edu 1995feb08
//

#include <stdio.h>
#include <assert.h>
#include "DataCombiner.h"

// ------------------------- DATAADDER object ---------------------------

#define OBJECT         DataStreamAdder
#define TCLNAME	       adder
#define ISCOMB		     /* one of ISSINK, ISSOURCE, ISPIPE or ISCOMB */
#define STRUCTFIELDS	\
        double scale1;	\
	double scale2;
#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, scale1, Scale1, "1.0")	\
	CONFIGLINE(TK_CONFIG_DOUBLE, scale2, Scale2, "1.0")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST
#define CONSTRUCTCODE(PTR, IN1, IN2)				\
	PTR->obj = new OBJECT(IN1, IN2, PTR->scale1, PTR->scale2);	
#define CONFIGCODE(PTR)						\
	if(ConfigSpecified("-scale1", argc, argv)		\
	   || ConfigSpecified("-scale2", argc, argv))  {	\
	    PTR->obj->SetScales(PTR->scale1, PTR->scale2);	\
	}
#include "tclTemplate.h"	// actually define the fns etc.

// ------------------------- DATAMULTER object ---------------------------

#define OBJECT         DataStreamMulter
#define TCLNAME	       multer
#define ISCOMB		     /* one of ISSINK, ISSOURCE, ISPIPE or ISCOMB */
#define STRUCTFIELDS	\
        double scale1;	\
	double scale2;
#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, scale1, Scale1, "1.0")	\
	CONFIGLINE(TK_CONFIG_DOUBLE, scale2, Scale2, "1.0")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST
#define CONSTRUCTCODE(PTR, IN1, IN2)				\
	PTR->obj = new OBJECT(IN1, IN2, PTR->scale1, PTR->scale2);	
#define CONFIGCODE(PTR)						\
	if(ConfigSpecified("-scale1", argc, argv)		\
	   || ConfigSpecified("-scale2", argc, argv))  {	\
	    PTR->obj->SetScales(PTR->scale1, PTR->scale2);	\
	}
#include "tclTemplate.h"	// actually define the fns etc.

