//
// tclSoundfileIO.cc
//
// tcl interface to SoundfileIO object
//
// for aprl - Soundfile pattern recognition language
// dpwe@media.mit.edu 1995feb08
//
#ifndef lint
static char rcsid[] = "$Header: /n/crab/da/dpwe/src/aprl/tclSoundfileIO.cc,v 1.1 1996/11/18 18:42:29 dpwe Exp $ @media.mit.edu Machine Listening Group";
#endif /* lint */

#include <stdio.h>
#include <assert.h>
#include "SoundfileIO.h"

// ----------------------- TEMPLATE DECLARATION OF SOUNDIFLESRC --------------

#define OBJECT		SoundfileSrc
#define TCLNAME		soundfsrc
#define ISSOURCE
#define STRUCTFIELDS		\
    int 	loop;		\
    char	*filename;	\
    double	bufferTime;	\
    double	scale;
#define CONFIGLINES						\
    CONFIGLINE(TK_CONFIG_INT, loop, Loop, "0")			\
    CONFIGLINE(TK_CONFIG_STRING, filename, Filename, "")	\
    CONFIGLINE(TK_CONFIG_DOUBLE, scale, Scale, "1.0")		\
    CONFIGLINE(TK_CONFIG_DOUBLE, bufferTime, BufferTime, "0.2")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR)						\
    PTR->obj = new SoundfileSrc(PTR->filename, PTR->bufferTime);	\
    PTR->obj->SetLoop(PTR->loop);					\
    PTR->obj->setScale(PTR->scale);
#define CONFIGCODE(PTR)			\
    PTR->obj->SetLoop(PTR->loop);	\
    PTR->obj->setScale(PTR->scale);	\
    if(PTR->obj->isOpen()==0)			\
        PTR->obj->newfile(PTR->filename);

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF SOUNDFILESINK --------------

#define OBJECT		SoundfileSink
#define TCLNAME		soundfsink
#define ISSINK
#define STRUCTFIELDS		\
    char	*filename;	\
    double	scale;	
#define CONFIGLINES		\
    CONFIGLINE(TK_CONFIG_DOUBLE, scale, Scale, "1.0")		\
    CONFIGLINE(TK_CONFIG_STRING, filename, Filename, "")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)			\
    else if( (c=='c') && strncmp(argv[1], "close", length)==0) {	\
	if(argc!=2)  {							\
	    Tcl_AppendResult(interp, "wrong # args: should be \"", 	\
			     argv[0], "close \"", NULL);		\
	    result = TCL_ERROR;						\
	} else {							\
	    ptr->obj->close();						\
	    result = TCL_OK;						\
	}								\
    }
#define COMMANDLIST	"/close"
#define CONSTRUCTCODE(PTR,IN)				\
    PTR->obj = new SoundfileSink(PTR->filename, IN);	\
    PTR->obj->setScale(PTR->scale);
#define CONFIGCODE(PTR)			\
    PTR->obj->setScale(PTR->scale);

#include "tclTemplate.h"
