/* this is an example 'user procedure' file
    eds 14 Feb 95 */

#include "assert.h"
#include <stdio.h>
#include "UserCmd.h"
#include <malloc.h>

/* needs to be here for the typedefs */

int num_cfuncs = 1;

/* num_cfuncs tells how many new procedures are being provided */

UserFunc gate;

name_table cnames[] = {
  {"gate",&gate}
};

/*
   cnames provides an association between functions you write and
   the names they get called by from APRL.
   
   if there are more, it looks like
     name_table cnames[] = {
       {"myfunc",&func1},
       {"myotherfunc",&func2},
       ...
       {"mylastfunc",&funcn}
     }

   all of the functions should be type UserFunc, which is
     typedef void UserFunc(UC_parm *parms,UC_parm *retval,int ct);
   in UserCmd.h

*/

#define THRESH .05

void gate(UC_parm *parms,UC_parm *retval,int /* ct */) {
  /* parms[0] is an audio signal,
     parms[1] is a control signal.

     pass the audio signal through to the output whenever
     the control signal is above THRESH
  */
  int i,j,pos;
  double dsfactor;

  retval->s = (DATA *)calloc(retval->length,sizeof(DATA));
  dsfactor = parms[0].length / parms[1].length;
  pos = 0;
  
  for (i=0;i!=parms[1].length;i++) {
    for (j=0;j<dsfactor;j++) {
      if (parms[1].s[i] > THRESH) 
	retval->s[pos] = parms[0].s[pos];
      else
	retval->s[pos] = 0;
      pos++;
    }
  }
}
  
