#
# afe_utils.tcl
#
# Functions used by both audio_frontend.tcl and send_afe_msg.tcl
# - part of the audio_frontend package.
#
# 1997jul18 dpwe@icsi.berkeley.edu
# $Header: /u/drspeech/src/audio_frontend/RCS/afe_utils.tcl,v 1.1 1997/07/19 00:40:41 dpwe Exp $

# ICSI initialization
# Copied here from ~dpwe/lib/share/tcl/utilfns.tcl
proc GetICSIargs {{acceptlist ""}} {
    # Process argc & argv in the manner of /u/drspeech/share/lib/icsiargs.tcl
    # If acceptlist is nonempty, accept only args in that list
    # Format is param=val, with no spaces around the =
    # Return list of params that were set.
    global argv argc
    set outargv ""
    set outargc 0
    set gotvars {}
    foreach p $argv {
	if {[string match "*=*" $p]} {
	    regexp {([^=]*)=(.*)} $p all param val
	    if {$acceptlist != ""} {
		if {[lsearch -exact $acceptlist $param] < 0} {
		    puts stderr "GetICSIargs: arg \"$param\" is not one of: $acceptlist"
		    # Maybe exit? or return null?  Just continue for now
		    continue
		}
	    }
	    uplevel #0 "set $param \{$val\}"
	    lappend gotvars $param
	} else {
	    # param doesn't contain "="
	    lappend outargv $p
	    incr outargc
	}
    }
    set argv $outargv
    set argc $outargc
    return $gotvars
}
